/*------------------------------------------------------------------------
  File: fw/conversion/20.01/fw-2001-after-01-fw-control.p
  Doel: converteren van de FW-database van 19.03 naar 20.01

  Programmeur: Simon Roest
               (c)Softpak BV
  Datum: 03/10/2019
------------------------------------------------------------------------*/
{system/conversion/conversion_progress.i}
DEFINE VARIABLE cProgram      AS CHARACTER NO-UNDO.
DEFINE VARIABLE cAction       AS CHARACTER NO-UNDO.
DEFINE VARIABLE iDone         AS INTEGER   NO-UNDO.
DEFINE VARIABLE iModulo       AS INTEGER   NO-UNDO.
DEFINE VARIABLE cListControl  AS CHARACTER NO-UNDO.
DEFINE VARIABLE iEntry        AS INTEGER   NO-UNDO.

DEFINE VARIABLE iLoop         AS INTEGER   NO-UNDO.

DEFINE BUFFER bfw-address          FOR fw-address.
DEFINE BUFFER bfw-control          FOR fw-control.
DEFINE BUFFER bfw-parameter-2      FOR fw-parameter-2.
DEFINE BUFFER bfw-parameter_bol    FOR fw-parameter_bol.
DEFINE BUFFER b-aa-edi-scheduler-poll FOR aa-edi-scheduler-poll.



DISABLE TRIGGERS FOR LOAD OF bfw-address.
DISABLE TRIGGERS FOR LOAD OF bfw-control.
DISABLE TRIGGERS FOR LOAD OF bfw-parameter-2.
DISABLE TRIGGERS FOR LOAD OF bfw-parameter_bol.

ASSIGN cProgram =  "fw-2001-after-01-fw-control.p"
       iModulo  =  1000.  /* om de 1000 records info tonen */

FORM "Program  :" AT 1 cProgram   NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Action   :" AT 1 cAction    NO-LABEL  FORMAT "x(50)"    AT 12  SKIP
     "Done     :" AT 1 iDone      NO-LABEL  FORMAT "9999999"  AT 12  SKIP
     WITH FRAME a.

/* LOGICA */
RUN DisplayProgress (cProgram, cAction, '', 0, iDone).

/* ----------------------------------------------------- */
/* Default is TEST, maar ook de fw-control geeft TEST    */
/* aan, dus eerst alles op LIVE zetten.                  */
/* ----------------------------------------------------- */
/* File Type was in de oude LBS-situatie hard gecodeerd, */
/* dat is nu een parameter, maar moet natuurlijk wel     */
/* even gevuld worden.                                   */
/* ----------------------------------------------------- */
/* Indien er in de oude LBS-situatie geen Shipper was    */
/* gedefinieerd werd standaard teruggevallen op de rol   */
/* SHIP. Deze zetten we hier als eerste, zodat hij gevuld*/
/* is als er geen fw-control-record aanwezig is.         */
/* ----------------------------------------------------- */
FOR EACH bfw-parameter-2
         EXCLUSIVE-LOCK
         TRANSACTION:

  iDone = iDone  + 1.
  IF iDone MODULO iModulo = 0 THEN RUN DisplayProgress (cProgram, cAction, '', 0, iDone).

  ASSIGN bfw-parameter-2.ifcsum_message_type = "LIVE"
         bfw-parameter-2.lbs_typecode        = "SFE"
         bfw-parameter-2.lbs_shipper         = "SHIP".
END.

FOR EACH bfw-control WHERE
         bfw-control.controlcode = "CC-ATTACHMENT"               OR
         bfw-control.controlcode = "EN-NO-TOTALS"                OR
         bfw-control.controlcode = "ACTION-INVOICEABLE"          OR
         bfw-control.controlcode = "NI-STATUS-LIST"              OR
         bfw-control.controlcode = "SKIP-QUESTION-PERIOD-UPDATE" OR
         bfw-control.controlcode = "XX-GENERAL-VALID"            OR
         bfw-control.controlcode = "ELK-INVOICE-QUICK-DUMP"      OR
         bfw-control.controlcode = "DD-AGS-GROSS-NET"            OR
         bfw-control.controlcode = "WDS-DD-INV-PERIOD"           OR
         bfw-control.controlcode = "PA-INVOICED-ONLY"            OR
         bfw-control.controlcode = "INTTRA-TEST-TELLER"          OR
         bfw-control.controlcode = "FW-EDI-TEST"                 OR
         bfw-control.controlcode = "LBS-DEBUG"                   OR
         bfw-control.controlcode = "LBS-IMPORTDIR"               OR
         bfw-control.controlcode = "LBS-FAILEDDIR"               OR
         bfw-control.controlcode = "LBS-FILEMATCH"               OR
         bfw-control.controlcode = "LBS-STATUSLOAD"              OR
         bfw-control.controlcode = "LBS-DEPARTMENT"              OR
         bfw-control.controlcode = "LBS-SPECPACK"                OR
         bfw-control.controlcode = "LBS-SPECSUBPACK"             OR
         bfw-control.controlcode = "LBS-CARRIAGE"                OR
         bfw-control.controlcode = "LBS-TRANSPORTTYPE"           OR
         bfw-control.controlcode = "LBS-DESTINATION"             OR
         bfw-control.controlcode = "LBS-BL-SHIPPER"              OR
         bfw-control.controlcode = "LBS-EMAIL"                   OR
         bfw-control.controlcode = "FW-COMPRESS-INVOICE"         OR
         bfw-control.controlcode = "VLS-BLOCK-TARIFFS"           OR
         bfw-control.controlcode = "RHB-CREATE-IC-TARIFFS"       OR
         bfw-control.controlcode = "TH-OVERRULE-ACTION-DEFAULTS"
         EXCLUSIVE-LOCK
         TRANSACTION:
  iDone = iDone  + 1.
  IF iDone MODULO iModulo = 0 THEN RUN DisplayProgress (cProgram, cAction, '', 0, iDone).

  FIND bfw-parameter-2 WHERE
       bfw-parameter-2.companycode = bfw-control.companycode
       EXCLUSIVE-LOCK NO-ERROR.

  IF AVAILABLE bfw-parameter-2
  THEN
  DO:
    CASE bfw-control.controlcode:

      WHEN "ACTION-INVOICEABLE"
      THEN ASSIGN bfw-parameter-2.ind_act_invoice_status = TRUE
                  bfw-parameter-2.act_invoice_excluded   = bfw-control.list.

      WHEN "CC-ATTACHMENT"
      THEN ASSIGN bfw-parameter-2.ind_tc_inherit_attachments = TRUE.

      WHEN "DD-AGS-GROSS-NET"
      THEN ASSIGN bfw-parameter-2.ind_ags_show_gross = TRUE.

      WHEN "ELK-INVOICE-QUICK-DUMP"
      THEN ASSIGN bfw-parameter-2.ind_inv_quick_dump = TRUE.

      WHEN "EN-NO-TOTALS"
      THEN ASSIGN bfw-parameter-2.ind_ship_omit_totals = TRUE.

      WHEN "FW-COMPRESS-INVOICE"
      THEN
      DO:
        IF bfw-control.list <> ""
        THEN
        DO iLoop = 1 TO NUM-ENTRIES(bfw-control.list):

          FIND bfw-address WHERE
               bfw-address.addressnr = INTEGER(ENTRY(iLoop, bfw-control.list))
               EXCLUSIVE-LOCK NO-ERROR.

          IF AVAILABLE bfw-address
          THEN ASSIGN bfw-address.ind_compress_invoice = TRUE
                      bfw-address.date-modified        = TODAY
                      bfw-address.user-modified        = "SOFTPAK".
        END.
      END.

      WHEN "FW-EDI-TEST"
      THEN ASSIGN bfw-parameter-2.ifcsum_message_type = "TEST".

      WHEN "INTTRA-TEST-TELLER"
      THEN ASSIGN bfw-parameter-2.inttra_br_counter_test = INTEGER(bfw-control.list) NO-ERROR.

      WHEN "LBS-BL-SHIPPER"
      THEN
      DO:
        IF CAN-FIND(fw-bl_role WHERE
                    fw-bl_role.rolecode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_shipper = bfw-control.list.
      END.

      WHEN "LBS-CARRIAGE"
      THEN
      DO:
        IF CAN-FIND(fw-carriage_type WHERE
                    fw-carriage_type.typecode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_carriage = bfw-control.list.
      END.

      WHEN "LBS-DEBUG"
      THEN ASSIGN bfw-parameter-2.ind_lbs_debug = (TRIM(bfw-control.list) = "yes")
                  bfw-parameter-2.lbs_debug_map = bfw-control.list-2.

      WHEN "LBS-DEPARTMENT"
      THEN
      DO:
        IF CAN-FIND(fw-department WHERE
                    fw-department.companycode    = bfw-control.companycode AND
                    fw-department.departmentcode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_departmentcode = bfw-control.list.
      END.

      WHEN "LBS-DESTINATION"
      THEN
      DO:
        IF CAN-FIND(fw-transport_type WHERE
                    fw-transport_type.typecode      = bfw-control.list AND
                    fw-transport_type.fieldtypecode = "T")
        THEN ASSIGN bfw-parameter-2.lbs_destination = bfw-control.list.
      END.

      WHEN "LBS-EMAIL"
      THEN ASSIGN bfw-parameter-2.lbs_email = bfw-control.list + bfw-control.list-2.

      WHEN "LBS-IMPORTDIR"
      THEN ASSIGN bfw-parameter-2.lbs_import_map = bfw-control.list.

      WHEN "LBS-FAILEDDIR"
      THEN ASSIGN bfw-parameter-2.lbs_failed_map = bfw-control.list.

      WHEN "LBS-FILEMATCH"
      THEN ASSIGN bfw-parameter-2.lbs_extension = bfw-control.list.

      WHEN "LBS-SPECPACK"
      THEN
      DO:
        IF CAN-FIND(aa-package WHERE
                    aa-package.packagecode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_packcode = bfw-control.list.
      END.

      WHEN "LBS-SPECSUBPACK"
      THEN
      DO:
        IF CAN-FIND(aa-package WHERE
                    aa-package.packagecode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_sub_packcode = bfw-control.list.
      END.

      WHEN "LBS-STATUSLOAD"
      THEN
      DO:
        IF CAN-FIND(fw-service WHERE
                    fw-service.servicecode = bfw-control.list)
        THEN ASSIGN bfw-parameter-2.lbs_status_load = bfw-control.list.
      END.

      WHEN "LBS-TRANSPORTTYPE"
      THEN
      DO:
        IF CAN-FIND(fw-transport_type WHERE
                    fw-transport_type.typecode      = bfw-control.list AND
                    fw-transport_type.fieldtypecode = "D")
        THEN ASSIGN bfw-parameter-2.lbs_transporttype = bfw-control.list.
      END.

      WHEN "NI-STATUS-LIST"
      THEN ASSIGN bfw-parameter-2.intake_status_string = bfw-control.list.

      WHEN "PA-INVOICED-ONLY"
      THEN ASSIGN bfw-parameter-2.ind_rep_invoiced_only = TRUE.

      WHEN "SKIP-QUESTION-PERIOD-UPDATE"
      THEN
      DO:
        FIND fw-parameter WHERE
             fw-parameter.companycode = bfw-parameter-2.companycode
             NO-LOCK NO-ERROR.

        IF fw-parameter.ind_automatic_period_update = TRUE
        THEN ASSIGN bfw-parameter-2.ind_confirm_period_update = TRUE.
      END.

      WHEN "XX-GENERAL-VALID"
      THEN ASSIGN bfw-parameter-2.ind_cont_ad_valid_only = TRUE.

      WHEN "WDS-DD-INV-PERIOD"
      THEN ASSIGN bfw-parameter-2.ind_cds_period = TRUE.

      WHEN "VLS-BLOCK-TARIFFS"
      THEN ASSIGN bfw-parameter-2.ind_block_tariffs = TRUE.

      WHEN "RHB-CREATE-IC-TARIFFS"
      THEN ASSIGN bfw-parameter-2.ind_create_ic_tariffs = TRUE.

      WHEN "TH-OVERRULE-ACTION-DEFAULTS"
      THEN ASSIGN bfw-parameter-2.ind_act_skip_default = TRUE.
    END CASE.

    ASSIGN bfw-parameter-2.date-modified = TODAY
           bfw-parameter-2.user-modified = "SOFTPAK".
  END.

  DELETE bfw-control.
END.

/* Portbase ladinginformatie */
cListControl = "PCS-ALERT-CODE,PCS-IDENTIFY,M1002_AUTO,PCS-BOL-ONE-ITEM-CONTAINER,PCS-FILE-SCHEDULER,PCS-FTP-IN-F100,PCS-FTP-IN-T100,PCS-FTP-IN-M1002,PCS-FTP-OUT,TERMINAL-WINSCP-PORTBASE,PCS-EDI-COMPANY,PCS-MAP-ERROR,PCS-OVERWRITE-SPECS,PCS-BOL-CREATE-ITEM-CONTAINER".
FOR EACH bfw-control WHERE
         LOOKUP(bfw-control.controlcode,cListControl) > 0
         EXCLUSIVE-LOCK
         TRANSACTION:

  iDone = iDone  + 1.
  IF iDone MODULO iModulo = 0 THEN RUN DisplayProgress (cProgram, cAction, '', 0, iDone).

  FIND bfw-parameter_bol WHERE
       bfw-parameter_bol.companycode = bfw-control.companycode
       EXCLUSIVE-LOCK NO-ERROR.

  IF NOT AVAILABLE bfw-parameter_bol
  THEN
  DO:
    CREATE bfw-parameter_bol.
    ASSIGN
        bfw-parameter_bol.companycode = bfw-control.companycode
        bfw-parameter_bol.ind_overwrite_specs = TRUE.
  END.

    CASE bfw-control.controlcode:
      WHEN "PCS-ALERT-CODE"
      THEN
       ASSIGN
         bfw-parameter_bol.alertcode = bfw-control.list.
      WHEN "PCS-IDENTIFY"
      THEN
        ASSIGN
          bfw-parameter_bol.pcs_identify_receiver = bfw-control.list
          bfw-parameter_bol.pcs_identify_sender   = bfw-control.list-2 .
      WHEN "M1002_AUTO"
      THEN
        ASSIGN
          bfw-parameter_bol.ind_auto-m1002 = true.
      WHEN "PCS-BOL-ONE-ITEM-CONTAINER"
      THEN
        ASSIGN
           bfw-parameter_bol.ind_one-item-container =  bfw-control.list = 'true'.
      WHEN "PCS-FILE-SCHEDULER"
      THEN
        ASSIGN
           bfw-parameter_bol.schedulerid_code = bfw-control.list.
      WHEN "PCS-FTP-IN-F100"
      THEN
       ASSIGN
        bfw-parameter_bol.ftp-in_F1000        = bfw-control.list.
      WHEN "PCS-FTP-IN-M1002"
      THEN
       ASSIGN
        bfw-parameter_bol.ftp-in_M1002        = bfw-control.list.
      WHEN "PCS-FTP-IN-T100"
      THEN
       ASSIGN
        bfw-parameter_bol.ftp-in_T1000        = bfw-control.list.
      WHEN "PCS-FTP-OUT"
      THEN
       ASSIGN
        bfw-parameter_bol.ftp_out             = bfw-control.list.
      WHEN "TERMINAL-WINSCP-PORTBASE"
      THEN
       ASSIGN
        bfw-parameter_bol.ind_scp             = true.
      WHEN "PCS-EDI-COMPANY"
      THEN
        ASSIGN
         bfw-parameter_bol.edi_company_code   = bfw-control.list.
      WHEN "PCS-MAP-ERROR"
      THEN
        ASSIGN
         bfw-parameter_bol.pcs-map-error      = bfw-control.list.
      WHEN "PCS-OVERWRITE-SPECS"
      THEN
        ASSIGN
         bfw-parameter_bol.ind_overwrite_specs   = bfw-control.list = 'true'.
      WHEN "PCS-BOL-CREATE-ITEM-CONTAINER"
      THEN
        ASSIGN
         bfw-parameter_bol.ind-create_item_container = bfw-control.list = 'true'.
    END CASE.

END.

FOR EACH b-aa-edi-scheduler-poll NO-LOCK
  WHERE b-aa-edi-scheduler-poll.stream_code = "BOLPCS"
  AND b-aa-edi-scheduler-poll.ind_inactive  = FALSE :

  FIND bfw-parameter_bol WHERE
       bfw-parameter_bol.companycode = b-aa-edi-scheduler-poll.pollcompany
    EXCLUSIVE-LOCK NO-ERROR.

  IF AVAILABLE bfw-parameter_bol
    THEN
    ASSIGN
      bfw-parameter_bol.pcs_addressnr = b-aa-edi-scheduler-poll.addressnr.

END.

RUN DisplayProgress (cProgram, cAction, '', 0, iDone).

